/*
 * _gen/svc-Connection_Interface_Forwarding.h - Header for TpSvcConnectionInterfaceForwarding
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CONNECTION_INTERFACE_FORWARDING_H__
#define __TP_SVC_CONNECTION_INTERFACE_FORWARDING_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcConnectionInterfaceForwarding:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcConnectionInterfaceForwarding TpSvcConnectionInterfaceForwarding;

/**
 * TpSvcConnectionInterfaceForwardingClass:
 *
 * The class of TpSvcConnectionInterfaceForwarding.
 */
typedef struct _TpSvcConnectionInterfaceForwardingClass TpSvcConnectionInterfaceForwardingClass;


GType tp_svc_connection_interface_forwarding_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CONNECTION_INTERFACE_FORWARDING \
  (tp_svc_connection_interface_forwarding_get_type ())
#define TP_SVC_CONNECTION_INTERFACE_FORWARDING(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_FORWARDING, TpSvcConnectionInterfaceForwarding))
#define TP_IS_SVC_CONNECTION_INTERFACE_FORWARDING(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_FORWARDING))
#define TP_SVC_CONNECTION_INTERFACE_FORWARDING_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_FORWARDING, TpSvcConnectionInterfaceForwardingClass))


typedef void (*tp_svc_connection_interface_forwarding_get_forwarding_handle_impl) (TpSvcConnectionInterfaceForwarding *self,
                                                                                   DBusGMethodInvocation *context);
void tp_svc_connection_interface_forwarding_implement_get_forwarding_handle (TpSvcConnectionInterfaceForwardingClass *klass, tp_svc_connection_interface_forwarding_get_forwarding_handle_impl impl);


/**
 * tp_svc_connection_interface_forwarding_return_from_get_forwarding_handle:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_forwarding_return_from_get_forwarding_handle (DBusGMethodInvocation *dbus_context,
                                                                          guint ret)
;
static inline void
tp_svc_connection_interface_forwarding_return_from_get_forwarding_handle (DBusGMethodInvocation *dbus_context,
                                                                          guint ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_interface_forwarding_set_forwarding_handle_impl) (TpSvcConnectionInterfaceForwarding *self,
                                                                                   guint forward_to,
                                                                                   DBusGMethodInvocation *context);
void tp_svc_connection_interface_forwarding_implement_set_forwarding_handle (TpSvcConnectionInterfaceForwardingClass *klass, tp_svc_connection_interface_forwarding_set_forwarding_handle_impl impl);


/**
 * tp_svc_connection_interface_forwarding_return_from_set_forwarding_handle:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_forwarding_return_from_set_forwarding_handle (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_interface_forwarding_return_from_set_forwarding_handle (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void tp_svc_connection_interface_forwarding_emit_forwarding_changed (gpointer instance,
    const guint  forward_to);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CONNECTION_INTERFACE_FORWARDING_H__*/
